package fovea.async {
	import fovea.async.Promise;
	public class Deferred implements fovea.async.Promise{
		public function Deferred() : void {
		}
		
		protected var _completeListeners : Array = new Array();
		protected var _failListeners : Array = new Array();
		protected var _finalCallback : Function;
		protected var _state : int = 0;
		protected var _outcome : *;
		public function resolve(outcome : * = null) : fovea.async.Deferred {
			if(this._state != 0) return this;
			this._outcome = outcome;
			this._state = 1;
			{
				var _g1 : int = 0;
				var _g : int = this._completeListeners.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					this._completeListeners[i](this._outcome);
				}
			};
			this.clearListeners();
			this.invokeFinalCallback();
			return this;
		}
		
		public function reject(error : Error) : fovea.async.Deferred {
			if(this._state != 0) return this;
			if(error != null) this._outcome = error;
			else this._outcome = new Error("Promise Rejected");
			this._state = 2;
			{
				var _g1 : int = 0;
				var _g : int = this._failListeners.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					this._failListeners[i](this._outcome);
				}
			};
			this.clearListeners();
			this.invokeFinalCallback();
			return this;
		}
		
		public function abort() : void {
			this._state = 3;
			this._outcome = null;
			this._finalCallback = null;
			this.clearListeners();
		}
		
		public function then(callback : Function) : fovea.async.Promise {
			if(this._state == 0) this._completeListeners.push(callback);
			else if(this._state == 1) callback(this._outcome);
			return this;
		}
		
		public function error(callback : Function) : fovea.async.Promise {
			if(this._state == 0) this._failListeners.push(callback);
			else if(this._state == 2) callback(this._outcome);
			return this;
		}
		
		public function always(callback : Function) : fovea.async.Promise {
			if(this._state == 0) this._finalCallback = callback;
			else callback();
			return this;
		}
		
		protected function clearListeners() : void {
			while(this._completeListeners.length > 0) this._completeListeners.pop();
			while(this._failListeners.length > 0) this._failListeners.pop();
		}
		
		protected function invokeFinalCallback() : void {
			if(this._finalCallback != null) {
				(this._finalCallback)();
				this._finalCallback = null;
			}
		}
		
		public function invert() : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.then(deferred.reject).error(deferred.resolve);
			return deferred;
		}
		
		static protected var PENDING : int = 0;
		static protected var RESOLVED : int = 1;
		static protected var REJECTED : int = 2;
		static protected var ABORTED : int = 3;
	}
}
