package fovea.async {
	import fovea.async.Deferred;
	import fovea.async.Promise;
	import haxe.Timer;
	public class Parallel {
		static public function run(fn : Array) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(fn.length == 0) {
				deferred.resolve();
				return deferred;
			};
			haxe.Timer.delay(function() : Function {
				var $r : Function;
				var onTick : Function = function() : void {
					var nCalls : int = 0;
					var done : Function = function(outcome : *) : void {
						nCalls += 1;
						if(nCalls == 2) deferred.resolve();
					};
					var f : Function = fn.shift();
					f().then(done).error(deferred.reject);
					fovea.async.Parallel.run(fn).then(done).error(deferred.reject);
				}
				$r = onTick;
				return $r;
			}(),0);
			return deferred;
		}
		
		static public function runWithArgs(args : Array,fn : Function) : fovea.async.Promise {
			return fovea.async.Parallel.privRunWithArgs(args.copy(),fn);
		}
		
		static protected function privRunWithArgs(args : Array,fn : Function) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(args.length == 0) {
				deferred.resolve();
				return deferred;
			};
			haxe.Timer.delay(function() : Function {
				var $r : Function;
				var onTick : Function = function() : void {
					var nCalls : int = 0;
					var done : Function = function(outcome : *) : void {
						nCalls += 1;
						if(nCalls == 2) deferred.resolve();
					};
					var a : * = args.shift();
					fn(a).then(done).error(deferred.reject);
					fovea.async.Parallel.privRunWithArgs(args,fn).then(done).error(deferred.reject);
				}
				$r = onTick;
				return $r;
			}(),0);
			return deferred;
		}
		
	}
}
