package fovea.ganomede {
	import fovea.async.Deferred;
	import fovea.ganomede.ApiError;
	import fovea.net.Ajax;
	import fovea.async.Promise;
	import haxe.Log;
	import fovea.net.AjaxError;
	import haxe.ds.StringMap;
	import flash.Boot;
	public class ApiClient extends fovea.net.Ajax {
		public function ApiClient(url : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(url);
		}}
		
		protected var cache : haxe.ds.StringMap = new haxe.ds.StringMap();
		public function service(type : String) : fovea.ganomede.ApiClient {
			var separator : String = "/";
			if(this.url.length > 0 && this.url.charAt(this.url.length - 1) == "/") separator = "";
			if(type.length > 0 && type.charAt(0) == "/") separator = "";
			return new fovea.ganomede.ApiClient(this.url + separator + type);
		}
		
		public function setCache(method : String,path : String,value : *) : void {
			var cacheID : String = method + ":" + path;
			this.cache.set(cacheID,value);
		}
		
		public function cached(method : String,path : String) : * {
			var key : String = method + ":" + path;
			if(this.cache.exists(key)) return this.cache.get(method + ":" + path);
			else return null;
			return null;
		}
		
		public function cachedAjax(method : String,path : String,options : * = null) : fovea.async.Promise {
			if(options == null) options = { };
			var obj : * = this.cached(method,path);
			if(obj != null) {
				var deferred : fovea.async.Deferred = new fovea.async.Deferred();
				deferred.resolve(obj);
				this.ajax(method,path,{ cache : true, parse : options.parse});
				return deferred;
			}
			else return this.ajax(method,path,{ cache : true, parse : options.parse});
			return null;
		}
		
		public function error(code : String,status : int = 0,data : * = null) : fovea.async.Promise {
			var p : fovea.async.Deferred = new fovea.async.Deferred();
			var e : fovea.ganomede.ApiError = new fovea.ganomede.ApiError(code,status,data);
			p.reject(e);
			return p;
		}
		
		public override function ajaxError(code : String,status : int = 0,data : * = null,url : String = null) : fovea.net.AjaxError {
			return new fovea.ganomede.ApiError(code,status,data,url);
		}
		
		public override function beforeAjax(options : *) : void {
			if(options.cache) {
				options.cacheID = Std.string(options.method) + ":" + Std.string(options.path);
				if(fovea.net.Ajax.verbose) haxe.Log._trace("AJAX[" + Std.string(options.requestID) + "]: will cache",{ fileName : "ApiClient.hx", lineNumber : 71, className : "fovea.ganomede.ApiClient", methodName : "beforeAjax"});
			}
		}
		
		public override function afterAjax(options : *,obj : *) : void {
			if(options.parse) obj.data = options.parse(obj.data);
			if(options.cacheID) this.cache.set(options.cacheID,obj);
		}
		
		public function ajaxGetData(path : String) : fovea.async.Deferred {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.ajax("GET",path).then(function(outcome : *) : void {
				if(outcome == null || outcome.data == null) deferred.reject(new fovea.ganomede.ApiError("IO"));
				else deferred.resolve(outcome.data);
			}).error(deferred.reject);
			return deferred;
		}
		
	}
}
