package fovea.ganomede {
	import fovea.ganomede.helpers.GanomedeTurnGameMover;
	import fovea.ganomede.GanomedeAvatars;
	import fovea.async.PromiseRunner;
	import fovea.ganomede.GanomedeGames;
	import fovea.ganomede.GanomedeTurnGamesComposite;
	import fovea.ganomede.GanomedeStatistics;
	import fovea.async.Deferred;
	import fovea.ganomede.GanomedeChats;
	import fovea.ganomede.GanomedeNotifications;
	import fovea.ganomede.GanomedeRegistry;
	import fovea.ganomede.GanomedeClientsPool;
	import fovea.async.Promise;
	import fovea.ganomede.helpers.GanomedeTurnGameInvitation;
	import fovea.ganomede.GanomedeUsers;
	import fovea.ganomede.GanomedeClient;
	import fovea.async.Waterfall;
	import fovea.ganomede.GanomedeInvitations;
	import flash.Boot;
	public class Ganomede {
		public function Ganomede(url : String = null,options : * = null) : void { if( !flash.Boot.skip_constructor ) {
			this.url = url;
			this.options = options;
		}}
		
		protected var pool : fovea.ganomede.GanomedeClientsPool = new fovea.ganomede.GanomedeClientsPool();
		public var client : fovea.ganomede.GanomedeClient;
		public var initialized : Boolean = false;
		public var registry : fovea.ganomede.GanomedeRegistry;
		public var users : fovea.ganomede.GanomedeUsers;
		public var invitations : fovea.ganomede.GanomedeInvitations;
		public var notifications : fovea.ganomede.GanomedeNotifications;
		public var games : fovea.ganomede.GanomedeGames;
		public var turngames : fovea.ganomede.GanomedeTurnGamesComposite;
		public var avatars : fovea.ganomede.GanomedeAvatars;
		public var statistics : fovea.ganomede.GanomedeStatistics;
		public var chats : fovea.ganomede.GanomedeChats;
		public var url : String;
		public var options : *;
		public function initialize() : fovea.async.Promise {
			var _g : fovea.ganomede.Ganomede = this;
			return this.pool.initializeClient(this.url,this.options).then(function(result : *) : void {
				_g.client = result.client;
				_g.registry = _g.client.registry;
				_g.users = _g.client.users;
				_g.invitations = _g.client.invitations;
				_g.notifications = _g.client.notifications;
				_g.games = _g.client.games;
				_g.turngames = new fovea.ganomede.GanomedeTurnGamesComposite(_g.client,_g.pool);
				_g.avatars = _g.client.avatars;
				_g.chats = _g.client.chats;
				_g.statistics = _g.client.statistics;
				_g.initialized = true;
				_g.callReady();
			});
		}
		
		protected var readyArray : Array = new Array();
		public function ready() : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(this.initialized) deferred.resolve(null);
			else this.readyArray.push(deferred);
			return deferred;
		}
		
		protected function callReady() : void {
			var a : Array = this.readyArray;
			this.readyArray = new Array();
			{
				var _g1 : int = 0;
				var _g : int = a.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					a[i].resolve(null);
				}
			}
		}
		
		public function _fake() : void {
			var pr : fovea.async.PromiseRunner = null;
			var wf : fovea.async.Waterfall = null;
			var tgi : fovea.ganomede.helpers.GanomedeTurnGameInvitation = null;
			var tgim : fovea.ganomede.helpers.GanomedeTurnGameMover = null;
		}
		
	}
}
