package fovea.ganomede {
	import flash.events.Event;
	import fovea.async.Deferred;
	import flash.events.HTTPStatusEvent;
	import fovea.net.Ajax;
	import flash.events.SecurityErrorEvent;
	import fovea.async.Promise;
	import haxe.Log;
	import flash.utils.ByteArray;
	import fovea.ganomede.GanomedeClient;
	import fovea.net.MultipartURLLoader;
	import flash.events.IOErrorEvent;
	import fovea.ganomede.ApiClient;
	import flash.Boot;
	public class GanomedeAvatars extends fovea.ganomede.ApiClient {
		public function GanomedeAvatars(client : fovea.ganomede.GanomedeClient = null) : void { if( !flash.Boot.skip_constructor ) {
			super(client.url + "/" + "avatars/v1");
			this.client = client;
		}}
		
		public var initialized : Boolean = false;
		public var cdnHost : String = null;
		public var client : fovea.ganomede.GanomedeClient;
		public function initialize() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeAvatars = this;
			return this.ajax("GET","/about").then(function(outcome : *) : void {
				var o : * = outcome.data;
				_g.initialized = true;
				if(o && o.config) {
					if(o.config.cdnHost) _g.cdnHost = o.config.cdnHost;
					else if(o.config.cdn) _g.cdnHost = o.config.cdn;
				}
			});
		}
		
		public function post(data : flash.utils.ByteArray) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeAvatars = this;
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(this.client.users == null) {
				deferred.reject(this.ajaxError("IO",400,{ message : "Users module not enabled"}));
				return deferred;
			};
			var token : String = this.client.users.me.token;
			var multipart : fovea.net.MultipartURLLoader = new fovea.net.MultipartURLLoader();
			multipart.addFile(data,"original.png","original","image/png");
			var endpoint : String = this.url + "/auth/" + token + "/pictures";
			var removeListeners : Function = null;
			var status : int = 0;
			var onComplete : Function = function(event : flash.events.Event) : void {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("[AVATARS] Complete (" + status + ")",{ fileName : "GanomedeAvatars.hx", lineNumber : 66, className : "fovea.ganomede.GanomedeAvatars", methodName : "post"});
				removeListeners();
				var obj : * = { status : status, url : _g.my("original.png")};
				_g.dispatchEvent(new flash.events.Event("ganomede.change"));
				deferred.resolve(obj);
			};
			var ioError : Function = function(event1 : flash.events.IOErrorEvent) : void {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("[AVATARS] ioError " + Std.string(event1),{ fileName : "GanomedeAvatars.hx", lineNumber : 76, className : "fovea.ganomede.GanomedeAvatars", methodName : "post"});
				removeListeners();
				deferred.reject(_g.ajaxError("IO",status));
			};
			var securityError : Function = function(event2 : flash.events.SecurityErrorEvent) : void {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("[AVATARS] securityError " + Std.string(event2),{ fileName : "GanomedeAvatars.hx", lineNumber : 81, className : "fovea.ganomede.GanomedeAvatars", methodName : "post"});
				removeListeners();
				deferred.reject(_g.ajaxError("SECURITY"));
			};
			var httpStatus : Function = function(event3 : flash.events.HTTPStatusEvent) : void {
				status = event3.status;
			};
			removeListeners = function() : void {
				multipart.removeEventListener(flash.events.Event.COMPLETE,onComplete);
				multipart.removeEventListener(flash.events.IOErrorEvent.IO_ERROR,ioError);
				multipart.removeEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR,securityError);
				multipart.removeEventListener(flash.events.HTTPStatusEvent.HTTP_STATUS,httpStatus);
			};
			multipart.addEventListener(flash.events.Event.COMPLETE,onComplete);
			multipart.addEventListener(flash.events.IOErrorEvent.IO_ERROR,ioError);
			multipart.addEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR,securityError);
			multipart.addEventListener(flash.events.HTTPStatusEvent.HTTP_STATUS,httpStatus);
			multipart.load(endpoint);
			return deferred;
		}
		
		public function user(username : String,version : String) : String {
			if(this.cdnHost != null) return "http://" + this.cdnHost + "/" + "avatars/v1" + "/" + username + "/" + version;
			else return this.url + "/" + username + "/" + version;
			return null;
		}
		
		public function my(version : String) : String {
			var username : String = this.client.users.me.username;
			return this.url + "/" + username + "/" + version + "?r=" + Math.random();
		}
		
		static public var TYPE : String = "avatars/v1";
	}
}
