package fovea.ganomede {
	import flash.events.Event;
	import fovea.ganomede.UserClient;
	import fovea.ganomede.AuthenticatedClient;
	import fovea.utils.Model;
	import fovea.net.Ajax;
	import fovea.async.Promise;
	import haxe.Log;
	import fovea.ganomede.GanomedeChatClient;
	import fovea.ganomede.GanomedeChatMessage;
	import fovea.ganomede.GanomedeClient;
	import fovea.ganomede.GanomedeNotificationEvent;
	import fovea.ganomede.GanomedeChatRoom;
	import fovea.ganomede.GanomedeChatEvent;
	import fovea.utils.Collection;
	import flash.Boot;
	public class GanomedeChats extends fovea.ganomede.UserClient {
		public function GanomedeChats(client : fovea.ganomede.GanomedeClient = null) : void { if( !flash.Boot.skip_constructor ) {
			super(client,this.chatClientFactory,"chat/v1");
			{
				var modelFactory : Function = function(json : *) : fovea.ganomede.GanomedeChatRoom {
					return new fovea.ganomede.GanomedeChatRoom(json);
				};
				this.collection.modelFactory = modelFactory;
			};
			this.addEventListener("reset",this.onReset);
			this.collection.addEventListener("change",this.dispatchEvent);
			if(client.notifications != null) client.notifications.listenTo("chat/v1",this.onChat);
		}}
		
		public var collection : fovea.utils.Collection = new fovea.utils.Collection();
		public function asArray() : Array {
			var array : Array = this.collection.asArray();
			array.sort((function($this:GanomedeChats) : Function {
				var $r : Function;
				var arrayComparator : Function = function(a : fovea.utils.Model,b : fovea.utils.Model) : int {
					var _as : String = (function() : fovea.ganomede.GanomedeChatRoom {
						var $r2 : fovea.ganomede.GanomedeChatRoom;
						var $t : fovea.utils.Model = a;
						if(Std._is($t,fovea.ganomede.GanomedeChatRoom)) (($t) as fovea.ganomede.GanomedeChatRoom);
						else throw "Class cast error";
						$r2 = $t;
						return $r2;
					}()).id;
					var bs : String = (function() : fovea.ganomede.GanomedeChatRoom {
						var $r3 : fovea.ganomede.GanomedeChatRoom;
						var $t : fovea.utils.Model = b;
						if(Std._is($t,fovea.ganomede.GanomedeChatRoom)) (($t) as fovea.ganomede.GanomedeChatRoom);
						else throw "Class cast error";
						$r3 = $t;
						return $r3;
					}()).id;
					if(_as < bs) return -1;
					if(_as > bs) return 1;
					return 0;
				}
				$r = arrayComparator;
				return $r;
			}(this)));
			return ((array) as Array);
		}
		
		public function toJSON() : * {
			return this.collection.toJSON();
		}
		
		protected function onChat(event : flash.events.Event) : void {
			var e : fovea.ganomede.GanomedeNotificationEvent = fovea.ganomede.GanomedeNotificationEvent(event);
			var data : * = e.notification.data;
			if(data != null && data.roomId != null) {
				var room : fovea.ganomede.GanomedeChatRoom = fovea.ganomede.GanomedeChatRoom(this.collection.get(data.roomId));
				if(room != null) {
					var msg : * = { timestamp : data.timestamp, from : data.from, type : data.type, message : data.message};
					room.messages.push(new fovea.ganomede.GanomedeChatMessage(msg));
					this.dispatchEvent(new fovea.ganomede.GanomedeChatEvent(room));
				}
			}
		}
		
		public function chatClientFactory(url : String,token : String) : fovea.ganomede.AuthenticatedClient {
			return new fovea.ganomede.GanomedeChatClient(url,token);
		}
		
		protected function onReset(event : flash.events.Event) : void {
			this.collection.flushall();
		}
		
		public function join(room : fovea.ganomede.GanomedeChatRoom) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeChats = this;
			if(!this.client.users.me.isAuthenticated()) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("cant join chat room: not authenticated",{ fileName : "GanomedeChats.hx", lineNumber : 80, className : "fovea.ganomede.GanomedeChats", methodName : "join"});
				return this.error("CLIENT");
			};
			if(room.type == null) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("cant join chat room: missing type",{ fileName : "GanomedeChats.hx", lineNumber : 84, className : "fovea.ganomede.GanomedeChats", methodName : "join"});
				return this.error("CLIENT");
			};
			if(room.users == null || room.users.length == 0) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("cant join chat room: no users",{ fileName : "GanomedeChats.hx", lineNumber : 88, className : "fovea.ganomede.GanomedeChats", methodName : "join"});
				return this.error("CLIENT");
			};
			return this.executeAuth((function($this:GanomedeChats) : Function {
				var $r : Function;
				var joinRoomFn : Function = function() : fovea.async.Promise {
					var chatClient : fovea.ganomede.GanomedeChatClient = fovea.ganomede.GanomedeChatClient(_g.authClient);
					return chatClient.joinRoom(room);
				}
				$r = joinRoomFn;
				return $r;
			}(this))).then((function($this:GanomedeChats) : Function {
				var $r2 : Function;
				var roomJoined : Function = function(outcome : *) : void {
					_g.collection.merge(room.toJSON());
				}
				$r2 = roomJoined;
				return $r2;
			}(this)));
		}
		
		public function postMessage(room : fovea.ganomede.GanomedeChatRoom,message : fovea.ganomede.GanomedeChatMessage) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeChats = this;
			return this.executeAuth((function($this:GanomedeChats) : Function {
				var $r : Function;
				var postMessageFn : Function = function() : fovea.async.Promise {
					var chatClient : fovea.ganomede.GanomedeChatClient = fovea.ganomede.GanomedeChatClient(_g.authClient);
					return chatClient.postMessage(room,message);
				}
				$r = postMessageFn;
				return $r;
			}(this))).then((function($this:GanomedeChats) : Function {
				var $r2 : Function;
				var messagePosted : Function = function(outcome : *) : void {
					room.messages.push(message);
				}
				$r2 = messagePosted;
				return $r2;
			}(this)));
		}
		
	}
}
