package fovea.ganomede {
	import fovea.async.Deferred;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeClient;
	import haxe.ds.StringMap;
	public class GanomedeClientsPool {
		public function GanomedeClientsPool() : void {
		}
		
		protected var pool : haxe.ds.StringMap = new haxe.ds.StringMap();
		protected var array : Array = new Array();
		public function initializeClient(url : String,options : *) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeClientsPool = this;
			var key : String = url;
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(!this.pool.exists(key)) {
				var client : fovea.ganomede.GanomedeClient = new fovea.ganomede.GanomedeClient(url,options);
				client.initialize().then(function(outcome : *) : void {
					var id : int = _g.array.length;
					_g.array.push(client);
					_g.pool.set(key,id);
					deferred.resolve({ id : id, client : client});
				}).error(function(err : Error) : void {
					deferred.reject(err);
				});
			}
			else {
				var id1 : * = this.pool.get(key);
				deferred.resolve({ id : id1, client : this.getClient(id1)});
			};
			return deferred;
		}
		
		public function getClient(id : int) : fovea.ganomede.GanomedeClient {
			return this.array[id];
		}
		
	}
}
