package fovea.ganomede {
	import fovea.ganomede.AuthenticatedClient;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeGame;
	import flash.Boot;
	public class GanomedeCoordinatorClient extends fovea.ganomede.AuthenticatedClient {
		public function GanomedeCoordinatorClient(baseUrl : String = null,token : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(baseUrl,"coordinator/v1",token);
		}}
		
		public function addGame(game : fovea.ganomede.GanomedeGame) : fovea.async.Promise {
			return this.ajax("POST","/" + game.type + "/games",{ data : { players : game.players}}).then(function(result : *) : void {
				if(result.data.id) game.fromJSON(result.data);
			});
		}
		
		public function getGame() : fovea.async.Promise {
			return this.ajax("GET","/game");
		}
		
		public function activeGames(type : String) : fovea.async.Promise {
			return this.ajax("GET","/" + type + "/active-games");
		}
		
		public function leaveGame(game : fovea.ganomede.GanomedeGame) : fovea.async.Promise {
			return this.ajax("POST","/games/" + game.id + "/leave").then(function(result : *) : void {
				if(result.data.id) game.fromJSON(result.data);
			});
		}
		
		public function joinGame(game : fovea.ganomede.GanomedeGame) : fovea.async.Promise {
			return this.ajax("POST","/games/" + game.id + "/join").then(function(result : *) : void {
				if(result.data.id) game.fromJSON(result.data);
			});
		}
		
		public function gameover(game : fovea.ganomede.GanomedeGame,gameOverData : *) : fovea.async.Promise {
			return this.ajax("POST","/games/" + game.id + "/gameover",{ data : { gameOverData : gameOverData}}).then(function(result : *) : void {
				if(result.data.id) game.fromJSON(result.data);
			});
		}
		
		static public var TYPE : String = "coordinator/v1";
	}
}
