package fovea.ganomede {
	import flash.events.Event;
	import fovea.ganomede.UserClient;
	import fovea.ganomede.AuthenticatedClient;
	import fovea.utils.Model;
	import fovea.net.Ajax;
	import fovea.ganomede.GanomedeCoordinatorClient;
	import fovea.async.Promise;
	import haxe.Log;
	import fovea.ganomede.GanomedeGame;
	import fovea.ganomede.GanomedeClient;
	import fovea.utils.Collection;
	import flash.Boot;
	public class GanomedeGames extends fovea.ganomede.UserClient {
		public function GanomedeGames(client : fovea.ganomede.GanomedeClient = null,type : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(client,this.coordinatorClientFactory);
			this.collection.keepStrategy = function(game : fovea.utils.Model) : Boolean {
				return (function() : fovea.ganomede.GanomedeGame {
					var $r : fovea.ganomede.GanomedeGame;
					var $t : fovea.utils.Model = game;
					if(Std._is($t,fovea.ganomede.GanomedeGame)) (($t) as fovea.ganomede.GanomedeGame);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}()).status == "active";
			};
			this.collection.modelFactory = function(json : *) : fovea.utils.Model {
				return new fovea.ganomede.GanomedeGame(json);
			};
			this.type = type;
			this.addEventListener("reset",this.onReset);
			this.collection.addEventListener("change",this.dispatchEvent);
		}}
		
		public var type : String;
		public var collection : fovea.utils.Collection = new fovea.utils.Collection();
		public function asArray() : Array {
			var array : Array = this.collection.asArray();
			array.sort(function(a : fovea.utils.Model,b : fovea.utils.Model) : int {
				if(a.id > b.id) return 1;
				else return -1;
				return 0;
			});
			return array;
		}
		
		public function toJSON() : * {
			return this.collection.toJSON();
		}
		
		protected function coordinatorClientFactory(url : String,token : String) : fovea.ganomede.AuthenticatedClient {
			return new fovea.ganomede.GanomedeCoordinatorClient(url,token);
		}
		
		public function onReset(event : flash.events.Event) : void {
			if(fovea.net.Ajax.verbose) haxe.Log._trace("reset!",{ fileName : "GanomedeGames.hx", lineNumber : 46, className : "fovea.ganomede.GanomedeGames", methodName : "onReset"});
			this.collection.flushall();
			this.refreshArray();
		}
		
		public function add(game : fovea.ganomede.GanomedeGame) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeGames = this;
			if(!this.client.users.me.isAuthenticated()) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("cant add game: not authenticated",{ fileName : "GanomedeGames.hx", lineNumber : 53, className : "fovea.ganomede.GanomedeGames", methodName : "add"});
				return this.error("CLIENT");
			};
			return this.executeAuth(function() : fovea.async.Promise {
				return (function() : fovea.ganomede.GanomedeCoordinatorClient {
					var $r : fovea.ganomede.GanomedeCoordinatorClient;
					var $t : fovea.ganomede.AuthenticatedClient = _g.authClient;
					if(Std._is($t,fovea.ganomede.GanomedeCoordinatorClient)) (($t) as fovea.ganomede.GanomedeCoordinatorClient);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}()).addGame(game);
			}).then(function(outcome : *) : void {
				_g.collection.merge(game.toJSON());
			});
		}
		
		public function join(game : fovea.ganomede.GanomedeGame) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeGames = this;
			return this.executeAuth(function() : fovea.async.Promise {
				return (function() : fovea.ganomede.GanomedeCoordinatorClient {
					var $r : fovea.ganomede.GanomedeCoordinatorClient;
					var $t : fovea.ganomede.AuthenticatedClient = _g.authClient;
					if(Std._is($t,fovea.ganomede.GanomedeCoordinatorClient)) (($t) as fovea.ganomede.GanomedeCoordinatorClient);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}()).joinGame(game);
			}).then(function(outcome : *) : void {
				_g.collection.merge(game.toJSON());
			});
		}
		
		public function leave(game : fovea.ganomede.GanomedeGame) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeGames = this;
			return this.executeAuth(function() : fovea.async.Promise {
				return (function() : fovea.ganomede.GanomedeCoordinatorClient {
					var $r : fovea.ganomede.GanomedeCoordinatorClient;
					var $t : fovea.ganomede.AuthenticatedClient = _g.authClient;
					if(Std._is($t,fovea.ganomede.GanomedeCoordinatorClient)) (($t) as fovea.ganomede.GanomedeCoordinatorClient);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}()).leaveGame(game);
			}).then(function(outcome : *) : void {
				_g.collection.merge(game.toJSON());
			});
		}
		
		public function gameover(game : fovea.ganomede.GanomedeGame,gameOverData : *) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeGames = this;
			return this.executeAuth(function() : fovea.async.Promise {
				return (function() : fovea.ganomede.GanomedeCoordinatorClient {
					var $r : fovea.ganomede.GanomedeCoordinatorClient;
					var $t : fovea.ganomede.AuthenticatedClient = _g.authClient;
					if(Std._is($t,fovea.ganomede.GanomedeCoordinatorClient)) (($t) as fovea.ganomede.GanomedeCoordinatorClient);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}()).gameover(game,gameOverData);
			}).then(function(outcome : *) : void {
				_g.collection.merge(game.toJSON());
			});
		}
		
		public function refreshArray() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeGames = this;
			return this.refreshCollection(this.collection,function() : fovea.async.Promise {
				return (function() : fovea.ganomede.GanomedeCoordinatorClient {
					var $r : fovea.ganomede.GanomedeCoordinatorClient;
					var $t : fovea.ganomede.AuthenticatedClient = _g.authClient;
					if(Std._is($t,fovea.ganomede.GanomedeCoordinatorClient)) (($t) as fovea.ganomede.GanomedeCoordinatorClient);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}()).activeGames(_g.type).then(function(outcome : *) : void {
					if(outcome == null) return;
					if(outcome.data == null) return;
					var array : Array;
					array = function() : Array {
						var $r2 : Array;
						var $t : * = outcome.data;
						if(Std._is($t,Array)) (($t) as Array);
						else throw "Class cast error";
						$r2 = $t;
						return $r2;
					}();
					if(array != null) {
						var _g2 : int = 0;
						var _g1 : int = array.length;
						while(_g2 < _g1) {
							var i : int = _g2++;
							array[i].status = "active";
						}
					}
				});
			});
		}
		
	}
}
