package fovea.ganomede {
	import flash.events.Event;
	import fovea.ganomede.UserClient;
	import fovea.ganomede.GanomedeInvitationsClient;
	import fovea.ganomede.AuthenticatedClient;
	import fovea.async.Deferred;
	import fovea.utils.Model;
	import fovea.net.Ajax;
	import fovea.async.Promise;
	import haxe.Log;
	import fovea.ganomede.GanomedeClient;
	import fovea.ganomede.GanomedeInvitation;
	import fovea.utils.Collection;
	import flash.Boot;
	public class GanomedeInvitations extends fovea.ganomede.UserClient {
		public function GanomedeInvitations(client : fovea.ganomede.GanomedeClient = null) : void { if( !flash.Boot.skip_constructor ) {
			var _g : fovea.ganomede.GanomedeInvitations = this;
			super(client,this.invitationsClientFactory,"invitations/v1");
			{
				var modelFactory : Function = function(json : *) : fovea.ganomede.GanomedeInvitation {
					return new fovea.ganomede.GanomedeInvitation(json);
				};
				this.collection.modelFactory = modelFactory;
			};
			this.addEventListener("reset",this.onReset);
			this.collection.addEventListener("change",this.dispatchEvent);
			if(client.notifications != null) client.notifications.listenTo("invitations/v1",(function($this:GanomedeInvitations) : Function {
				var $r : Function;
				var invitationNotification : Function = function(event : flash.events.Event) : void {
					_g.refreshArray();
				}
				$r = invitationNotification;
				return $r;
			}(this)));
		}}
		
		public var collection : fovea.utils.Collection = new fovea.utils.Collection();
		public function asArray() : Array {
			var array : Array = this.collection.asArray();
			array.sort((function($this:GanomedeInvitations) : Function {
				var $r : Function;
				var arrayComparator : Function = function(a : fovea.utils.Model,b : fovea.utils.Model) : int {
					return (function() : fovea.ganomede.GanomedeInvitation {
						var $r2 : fovea.ganomede.GanomedeInvitation;
						var $t : fovea.utils.Model = a;
						if(Std._is($t,fovea.ganomede.GanomedeInvitation)) (($t) as fovea.ganomede.GanomedeInvitation);
						else throw "Class cast error";
						$r2 = $t;
						return $r2;
					}()).index - (function() : fovea.ganomede.GanomedeInvitation {
						var $r3 : fovea.ganomede.GanomedeInvitation;
						var $t : fovea.utils.Model = b;
						if(Std._is($t,fovea.ganomede.GanomedeInvitation)) (($t) as fovea.ganomede.GanomedeInvitation);
						else throw "Class cast error";
						$r3 = $t;
						return $r3;
					}()).index;
				}
				$r = arrayComparator;
				return $r;
			}(this)));
			return ((array) as Array);
		}
		
		public function toJSON() : * {
			return this.collection.toJSON();
		}
		
		public function invitationsClientFactory(url : String,token : String) : fovea.ganomede.AuthenticatedClient {
			return new fovea.ganomede.GanomedeInvitationsClient(url,token);
		}
		
		protected function onReset(event : flash.events.Event) : void {
			this.collection.flushall();
			this.refreshArray();
		}
		
		public function add(invitation : fovea.ganomede.GanomedeInvitation) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeInvitations = this;
			if(!this.client.users.me.isAuthenticated()) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("cant add invitation: not authenticated",{ fileName : "GanomedeInvitations.hx", lineNumber : 52, className : "fovea.ganomede.GanomedeInvitations", methodName : "add"});
				return this.error("CLIENT");
			};
			invitation.from = this.client.users.me.username;
			return this.executeAuth((function($this:GanomedeInvitations) : Function {
				var $r : Function;
				var addInvitationFn : Function = function() : fovea.async.Promise {
					var invitationsClient : fovea.ganomede.GanomedeInvitationsClient = fovea.ganomede.GanomedeInvitationsClient(_g.authClient);
					return invitationsClient.addInvitation(invitation);
				}
				$r = addInvitationFn;
				return $r;
			}(this))).then((function($this:GanomedeInvitations) : Function {
				var $r2 : Function;
				var invitationAdded : Function = function(outcome : *) : void {
					_g.collection.merge(invitation.toJSON());
				}
				$r2 = invitationAdded;
				return $r2;
			}(this)));
		}
		
		public function cancel(invitation : fovea.ganomede.GanomedeInvitation) : fovea.async.Promise {
			return this.deleteInvitation(invitation,"cancel");
		}
		
		public function accept(invitation : fovea.ganomede.GanomedeInvitation) : fovea.async.Promise {
			return this.deleteInvitation(invitation,"accept");
		}
		
		public function refuse(invitation : fovea.ganomede.GanomedeInvitation) : fovea.async.Promise {
			return this.deleteInvitation(invitation,"refuse");
		}
		
		protected function deleteInvitation(invitation : fovea.ganomede.GanomedeInvitation,reason : String) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeInvitations = this;
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.executeAuth((function($this:GanomedeInvitations) : Function {
				var $r : Function;
				var deleteInvitationFn : Function = function() : fovea.async.Promise {
					var invitationsClient : fovea.ganomede.GanomedeInvitationsClient = fovea.ganomede.GanomedeInvitationsClient(_g.authClient);
					return invitationsClient.deleteInvitation(invitation,reason);
				}
				$r = deleteInvitationFn;
				return $r;
			}(this))).then((function($this:GanomedeInvitations) : Function {
				var $r2 : Function;
				var invitationDeleted : Function = function(outcome : *) : void {
					_g.collection.del(invitation.id);
					_g.dispatchEvent(new flash.events.Event("change"));
					deferred.resolve();
				}
				$r2 = invitationDeleted;
				return $r2;
			}(this))).error(deferred.reject);
			return deferred;
		}
		
		public function refreshArray() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeInvitations = this;
			return this.refreshCollection(this.collection,(function($this:GanomedeInvitations) : Function {
				var $r : Function;
				var arrayRefreshed : Function = function() : fovea.async.Promise {
					return (function() : fovea.ganomede.GanomedeInvitationsClient {
						var $r2 : fovea.ganomede.GanomedeInvitationsClient;
						var $t : fovea.ganomede.AuthenticatedClient = _g.authClient;
						if(Std._is($t,fovea.ganomede.GanomedeInvitationsClient)) (($t) as fovea.ganomede.GanomedeInvitationsClient);
						else throw "Class cast error";
						$r2 = $t;
						return $r2;
					}()).listInvitations();
				}
				$r = arrayRefreshed;
				return $r;
			}(this)));
		}
		
	}
}
