package fovea.ganomede {
	import fovea.ganomede.AuthenticatedClient;
	import fovea.async.Deferred;
	import fovea.ganomede.ApiError;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeInvitation;
	import flash.Boot;
	public class GanomedeInvitationsClient extends fovea.ganomede.AuthenticatedClient {
		public function GanomedeInvitationsClient(baseUrl : String = null,token : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(baseUrl,"invitations/v1",token);
		}}
		
		public function addInvitation(invitation : fovea.ganomede.GanomedeInvitation) : fovea.async.Promise {
			return this.ajax("POST","/invitations",{ data : { gameId : invitation.gameId, type : invitation.type, to : invitation.to}}).then((function($this:GanomedeInvitationsClient) : Function {
				var $r : Function;
				var invitationAdded : Function = function(result : *) : void {
					if(result.data.id) invitation.id = result.data.id;
				}
				$r = invitationAdded;
				return $r;
			}(this)));
		}
		
		public function listInvitations() : fovea.async.Promise {
			return this.ajax("GET","/invitations");
		}
		
		public function deleteInvitation(invite : fovea.ganomede.GanomedeInvitation,reason : String) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.ajax("POST","/invitations/" + invite.id + "/delete",{ data : { reason : reason}}).then((function($this:GanomedeInvitationsClient) : Function {
				var $r : Function;
				var invitationDeleted : Function = function(result : *) : void {
					if(!result.data || result.data.ok == true) deferred.resolve();
					else deferred.reject(new fovea.ganomede.ApiError("HTTP",result.status,result.data));
				}
				$r = invitationDeleted;
				return $r;
			}(this))).error(deferred.reject);
			return deferred;
		}
		
		static public var TYPE : String = "invitations/v1";
	}
}
