package fovea.ganomede {
	import flash.events.Event;
	import fovea.ganomede.GanomedeNotification;
	import fovea.ganomede.UserClient;
	import fovea.ganomede.GanomedeService;
	import fovea.ganomede.AuthenticatedClient;
	import fovea.async.Deferred;
	import fovea.net.Ajax;
	import fovea.async.Promise;
	import haxe.Log;
	import fovea.ganomede.GanomedeClient;
	import fovea.ganomede.GanomedePushToken;
	import fovea.ganomede.GanomedeNotificationEvent;
	import fovea.ganomede.GanomedeNotificationsClient;
	import haxe.Timer;
	import flash.Boot;
	public class GanomedeNotifications extends fovea.ganomede.UserClient {
		public function GanomedeNotifications(client : fovea.ganomede.GanomedeClient = null) : void { if( !flash.Boot.skip_constructor ) {
			super(client,this.notificationsClientFactory,"notifications/v1");
			this.addEventListener("change:initialize",this.onInitialize);
			this.addEventListener("reset",this.onReset);
		}}
		
		public function notificationsClientFactory(url : String,token : String) : fovea.ganomede.AuthenticatedClient {
			return new fovea.ganomede.GanomedeNotificationsClient(url,token);
		}
		
		public function listenTo(emiter : String,callback : Function) : void {
			this.on(emiter,callback);
		}
		
		protected var lastId : int = -1;
		protected function onPollSuccess(result : *) : void {
			try {
				var notifClient : fovea.ganomede.GanomedeNotificationsClient = fovea.ganomede.GanomedeNotificationsClient(this.authClient);
				var notifications : Array;
				notifications = (function($this:GanomedeNotifications) : Array {
					var $r : Array;
					var $t : * = result.data;
					if(Std._is($t,Array)) (($t) as Array);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}(this));
				if(fovea.net.Ajax.verbose) haxe.Log._trace("[GanomedeNotifications] results for " + Std.string(result.token),{ fileName : "GanomedeNotifications.hx", lineNumber : 35, className : "fovea.ganomede.GanomedeNotifications", methodName : "onPollSuccess"});
				if(notifications == null || result.token != notifClient.token || result.clientId != notifClient.clientId) {
					if(fovea.net.Ajax.verbose && notifications != null) haxe.Log._trace("skip",{ fileName : "GanomedeNotifications.hx", lineNumber : 38, className : "fovea.ganomede.GanomedeNotifications", methodName : "onPollSuccess"});
					haxe.Timer.delay(this.poll,100);
					return;
				};
				{
					var _g1 : int = 0;
					var _g : int = notifications.length;
					while(_g1 < _g) {
						var i : int = _g1++;
						var n : fovea.ganomede.GanomedeNotification = notifications[notifications.length - i - 1];
						if(n.id > this.lastId) this.lastId = n.id;
						if(!result.silent) this.dispatchNotification(n);
					}
				}
			}
			catch( error : String ){
				if(fovea.net.Ajax.verbose) haxe.Log._trace("[GanomedeNotifications] ERROR " + error,{ fileName : "GanomedeNotifications.hx", lineNumber : 51, className : "fovea.ganomede.GanomedeNotifications", methodName : "onPollSuccess"});
			};
			haxe.Timer.delay(this.poll,100);
		}
		
		protected function onPollError(error : Error) : void {
			haxe.Timer.delay(this.poll,1000);
		}
		
		public function poll() : void {
			var _g : fovea.ganomede.GanomedeNotifications = this;
			var notifClient : fovea.ganomede.GanomedeNotificationsClient = fovea.ganomede.GanomedeNotificationsClient(this.authClient);
			if(!notifClient.polling) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("[GanomedeNotifications] poll",{ fileName : "GanomedeNotifications.hx", lineNumber : 61, className : "fovea.ganomede.GanomedeNotifications", methodName : "poll"});
				this.executeAuth(function() : fovea.async.Promise {
					return notifClient.poll(_g.lastId);
				}).then(this.onPollSuccess).error(this.onPollError);
			}
		}
		
		public function silentPoll() : void {
			var _g : fovea.ganomede.GanomedeNotifications = this;
			var notifClient : fovea.ganomede.GanomedeNotificationsClient = fovea.ganomede.GanomedeNotificationsClient(this.authClient);
			if(this.isAuthOK()) this.executeAuth(function() : fovea.async.Promise {
				return notifClient.poll(-2);
			}).then(function(result : *) : void {
				result.silent = true;
				_g.onPollSuccess(result);
			}).error(function(err : Error) : void {
				haxe.Timer.delay(_g.silentPoll,1000);
			});
			else haxe.Timer.delay(this.silentPoll,1000);
		}
		
		protected function onInitialize(event : flash.events.Event) : void {
			this.silentPoll();
			var timer : haxe.Timer = new haxe.Timer(60000);
			timer.run = this.poll;
		}
		
		protected function onReset(event : flash.events.Event) : void {
			this.lastId = -1;
			this.silentPoll();
		}
		
		protected function dispatchNotification(n : fovea.ganomede.GanomedeNotification) : void {
			if(fovea.net.Ajax.verbose) haxe.Log._trace("[GanomedeNotifications] notification: " + JSON.stringify(n.toJSON()),{ fileName : "GanomedeNotifications.hx", lineNumber : 101, className : "fovea.ganomede.GanomedeNotifications", methodName : "dispatchNotification"});
			this.dispatchEvent(new fovea.ganomede.GanomedeNotificationEvent(n));
		}
		
		public var apiSecret : String = "";
		public function send(n : fovea.ganomede.GanomedeNotification) : fovea.async.Promise {
			var data : * = n.toJSON();
			data.secret = this.apiSecret;
			return this.ajax("POST","/messages",{ data : data});
		}
		
		public var online : Array = [];
		public function refreshOnline() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeNotifications = this;
			var method : String = "GET";
			var endpoint : String = "/online";
			var service : fovea.ganomede.GanomedeService = this.client.registry.getService("notifications",1);
			var postSupported : Boolean = service != null && service.versionGE(1,1,0);
			if(this.client.users.me != null && postSupported) {
				var token : String = this.client.users.me.token;
				if(token != null) {
					method = "POST";
					endpoint = "/auth/" + token + "/online";
				}
			};
			return this.ajax(method,endpoint).then(function(outcome : *) : void {
				_g.online = outcome.data;
			});
		}
		
		public function savePushToken(pushToken : fovea.ganomede.GanomedePushToken) : fovea.async.Promise {
			if(this.client.users.me != null) {
				var token : String = this.client.users.me.token;
				var endpoint : String = "/auth/" + token + "/push-token";
				return this.ajax("POST",endpoint,{ data : pushToken.toJSON()});
			}
			else return new fovea.async.Deferred().reject(new Error("Not authenticated"));
			return null;
		}
		
	}
}
