package fovea.ganomede {
	import fovea.ganomede.GanomedeTurnGame;
	import fovea.ganomede.AuthenticatedClient;
	import fovea.async.Deferred;
	import fovea.ganomede.ApiError;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeTurnMove;
	import flash.Boot;
	public class GanomedeTurnGameClient extends fovea.ganomede.AuthenticatedClient {
		public function GanomedeTurnGameClient(baseUrl : String = null,token : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(baseUrl,"turngame/v1",token);
		}}
		
		public function getGame(game : fovea.ganomede.GanomedeTurnGame) : fovea.async.Promise {
			if(game.id == null) {
				var deferred : fovea.async.Deferred = new fovea.async.Deferred();
				deferred.reject(new fovea.ganomede.ApiError("HTTP",400));
				return deferred;
			};
			return this.ajax("GET","/games/" + game.id).then(function(result : *) : void {
				game.fromJSON(result.data);
			});
		}
		
		public function addGame(game : fovea.ganomede.GanomedeTurnGame) : fovea.async.Promise {
			if(game.id == null) {
				var deferred : fovea.async.Deferred = new fovea.async.Deferred();
				deferred.reject(new fovea.ganomede.ApiError("HTTP",400));
				return deferred;
			};
			return this.ajax("POST","/games/" + game.id,{ data : game.toJSON()}).then(function(result : *) : void {
				game.fromJSON(result.data);
			});
		}
		
		public function addMove(game : fovea.ganomede.GanomedeTurnGame,move : fovea.ganomede.GanomedeTurnMove) : fovea.async.Promise {
			if(game.id == null) {
				var deferred : fovea.async.Deferred = new fovea.async.Deferred();
				deferred.reject(new fovea.ganomede.ApiError("HTTP",400));
				return deferred;
			};
			return this.ajax("POST","/games/" + game.id + "/moves",{ data : move.toJSON()}).then(function(result : *) : void {
				game.fromJSON(result.data);
				move.fromJSON(result.data);
			});
		}
		
		static public var TYPE : String = "turngame/v1";
	}
}
