package fovea.ganomede {
	import flash.events.Event;
	import fovea.ganomede.UserClient;
	import fovea.ganomede.AuthenticatedClient;
	import fovea.ganomede.GanomedeTurnGame;
	import fovea.async.Deferred;
	import fovea.utils.Model;
	import fovea.ganomede.GanomedeTurnGameClient;
	import fovea.net.Ajax;
	import fovea.async.Promise;
	import haxe.Log;
	import fovea.ganomede.GanomedeClient;
	import fovea.async.Parallel;
	import fovea.ganomede.GanomedeNotificationEvent;
	import fovea.ganomede.GanomedeTurnMove;
	import fovea.utils.Collection;
	import flash.Boot;
	public class GanomedeTurnGames extends fovea.ganomede.UserClient {
		public function GanomedeTurnGames(client : fovea.ganomede.GanomedeClient = null) : void { if( !flash.Boot.skip_constructor ) {
			var _g : fovea.ganomede.GanomedeTurnGames = this;
			super(client,this.turngameClientFactory,"turngame/v1");
			this.collection.modelFactory = function(json : *) : fovea.ganomede.GanomedeTurnGame {
				return new fovea.ganomede.GanomedeTurnGame(json);
			};
			this.addEventListener("reset",this.onReset);
			this.collection.addEventListener("change",this.dispatchEvent);
			if(client.notifications != null) client.notifications.listenTo("turngame/v1",function(e : flash.events.Event) : void {
				var event : fovea.ganomede.GanomedeNotificationEvent = fovea.ganomede.GanomedeNotificationEvent(e);
				if(event.notification.type == "move") _g.collection.merge(event.notification.data.game);
			});
		}}
		
		public var collection : fovea.utils.Collection = new fovea.utils.Collection();
		public function toJSON() : * {
			return this.collection.toJSON();
		}
		
		public function turngameClientFactory(url : String,token : String) : fovea.ganomede.AuthenticatedClient {
			return new fovea.ganomede.GanomedeTurnGameClient(url,token);
		}
		
		protected function onReset(event : flash.events.Event) : void {
			this.collection.flushall();
		}
		
		public function get(id : String) : fovea.ganomede.GanomedeTurnGame {
			return (function($this:GanomedeTurnGames) : fovea.ganomede.GanomedeTurnGame {
				var $r : fovea.ganomede.GanomedeTurnGame;
				var $t : fovea.utils.Model = $this.collection.get(id);
				if(Std._is($t,fovea.ganomede.GanomedeTurnGame)) (($t) as fovea.ganomede.GanomedeTurnGame);
				else throw "Class cast error";
				$r = $t;
				return $r;
			}(this));
		}
		
		public function add(turngame : fovea.ganomede.GanomedeTurnGame) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeTurnGames = this;
			if(!this.client.users.me.isAuthenticated()) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("cant create turngame: not authenticated",{ fileName : "GanomedeTurnGames.hx", lineNumber : 61, className : "fovea.ganomede.GanomedeTurnGames", methodName : "add"});
				return this.error("CLIENT");
			};
			return this.executeAuth(function() : fovea.async.Promise {
				var turngamesClient : fovea.ganomede.GanomedeTurnGameClient = fovea.ganomede.GanomedeTurnGameClient(_g.authClient);
				return turngamesClient.addGame(turngame);
			}).then(function(outcome : *) : void {
				_g.collection.merge(turngame.toJSON());
			});
		}
		
		public function refresh(turngame : fovea.ganomede.GanomedeTurnGame) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeTurnGames = this;
			if(!this.client.users.me.isAuthenticated()) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("cant load turngame: not authenticated",{ fileName : "GanomedeTurnGames.hx", lineNumber : 75, className : "fovea.ganomede.GanomedeTurnGames", methodName : "refresh"});
				return this.error("CLIENT");
			};
			return this.executeAuth(function() : fovea.async.Promise {
				var turngamesClient : fovea.ganomede.GanomedeTurnGameClient = fovea.ganomede.GanomedeTurnGameClient(_g.authClient);
				return turngamesClient.getGame(turngame);
			}).then(function(outcome : *) : void {
				_g.collection.merge(turngame.toJSON());
			});
		}
		
		public function addMove(turngame : fovea.ganomede.GanomedeTurnGame,move : fovea.ganomede.GanomedeTurnMove) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeTurnGames = this;
			if(!this.client.users.me.isAuthenticated()) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("cant add move to turngame: not authenticated",{ fileName : "GanomedeTurnGames.hx", lineNumber : 89, className : "fovea.ganomede.GanomedeTurnGames", methodName : "addMove"});
				return this.error("CLIENT");
			};
			return this.executeAuth(function() : fovea.async.Promise {
				var turngamesClient : fovea.ganomede.GanomedeTurnGameClient = fovea.ganomede.GanomedeTurnGameClient(_g.authClient);
				return turngamesClient.addMove(turngame,move);
			}).then(function(outcome : *) : void {
				_g.collection.merge(turngame.toJSON());
			});
		}
		
		public function refreshArray(array : Array) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeTurnGames = this;
			return fovea.async.Parallel.runWithArgs(array,function(id : String) : fovea.async.Promise {
				var deferred : fovea.async.Deferred = new fovea.async.Deferred();
				_g.refresh(new fovea.ganomede.GanomedeTurnGame({ id : id})).then(deferred.resolve).error(function(err : Error) : void {
					if(fovea.net.Ajax.verbose) haxe.Log._trace("failed to refresh turngame(" + id + "): " + Std.string(err),{ fileName : "GanomedeTurnGames.hx", lineNumber : 108, className : "fovea.ganomede.GanomedeTurnGames", methodName : "refreshArray"});
					deferred.resolve(null);
				});
				return deferred;
			});
		}
		
	}
}
