package fovea.ganomede {
	import fovea.ganomede.GanomedeUser;
	import flash.events.Event;
	import fovea.events.Events;
	import fovea.ganomede.GanomedeTurnGame;
	import fovea.async.Deferred;
	import fovea.ganomede.ApiError;
	import fovea.ganomede.GanomedeClientsPool;
	import fovea.ganomede.GanomedeTurnGameEvent;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeClient;
	import fovea.async.Parallel;
	import fovea.ganomede.GanomedeNotificationEvent;
	import haxe.ds.StringMap;
	import fovea.ganomede.GanomedeTurnMove;
	import flash.Boot;
	public class GanomedeTurnGamesComposite extends fovea.events.Events {
		public function GanomedeTurnGamesComposite(client : fovea.ganomede.GanomedeClient = null,pool : fovea.ganomede.GanomedeClientsPool = null) : void { if( !flash.Boot.skip_constructor ) {
			super();
			this.pool = pool;
			this.client = client;
		}}
		
		public var pool : fovea.ganomede.GanomedeClientsPool;
		public var client : fovea.ganomede.GanomedeClient;
		protected var idMap : haxe.ds.StringMap = new haxe.ds.StringMap();
		public function add(turngame : fovea.ganomede.GanomedeTurnGame) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.prepareClient(turngame).then((function($this:GanomedeTurnGamesComposite) : Function {
				var $r : Function;
				var clientPrepared : Function = function(result : *) : void {
					var client : fovea.ganomede.GanomedeClient = fovea.ganomede.GanomedeClient(result.client);
					if(client == null || client.turngames == null) {
						deferred.reject(new fovea.ganomede.ApiError("CLIENT",400));
						return;
					};
					client.turngames.add(turngame).then(deferred.resolve).error(deferred.reject);
				}
				$r = clientPrepared;
				return $r;
			}(this))).error(deferred.reject);
			return deferred;
		}
		
		protected var listenedToMap : haxe.ds.StringMap = new haxe.ds.StringMap();
		protected function listenToClient(id : int,client : fovea.ganomede.GanomedeClient) : void {
			var _g : fovea.ganomede.GanomedeTurnGamesComposite = this;
			if(this.listenedToMap.exists("" + id)) return;
			this.listenedToMap.set("" + id,true);
			if(client.notifications != null) client.notifications.listenTo("turngame/v1",(function($this:GanomedeTurnGamesComposite) : Function {
				var $r : Function;
				var turngameNotification : Function = function(e : flash.events.Event) : void {
					var event : fovea.ganomede.GanomedeNotificationEvent = fovea.ganomede.GanomedeNotificationEvent(e);
					if(event.notification.type == "move") {
						var gameJson : * = event.notification.data.game;
						var game : fovea.ganomede.GanomedeTurnGame = _g.get(gameJson.id);
						if(game != null) {
							game.fromJSON(gameJson);
							_g.dispatchEvent(new fovea.ganomede.GanomedeTurnGameEvent(game));
						}
					}
				}
				$r = turngameNotification;
				return $r;
			}(this)));
		}
		
		protected function prepareClient(game : fovea.ganomede.GanomedeTurnGame) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeTurnGamesComposite = this;
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.pool.initializeClient(game.url,{ turngames : { enabled : true}, users : { enabled : true}, notifications : { enabled : true}}).then((function($this:GanomedeTurnGamesComposite) : Function {
				var $r : Function;
				var clientInitialized : Function = function(result : *) : void {
					var client : fovea.ganomede.GanomedeClient = fovea.ganomede.GanomedeClient(result.client);
					if(client == null) {
						deferred.reject(new fovea.ganomede.ApiError("CLIENT",400));
						return;
					};
					_g.listenToClient(result.id,client);
					if(!client.users.me.isAuthenticated()) client.users.login(new fovea.ganomede.GanomedeUser({ username : _g.client.users.me.username, password : _g.client.users.me.password})).then(function() : Function {
						var $r2 : Function;
						var userLoggedIn : Function = function(outcome : *) : void {
							_g.idMap.set(game.id,result.id);
							deferred.resolve(result);
						}
						$r2 = userLoggedIn;
						return $r2;
					}()).error(deferred.reject);
					else deferred.resolve(result);
				}
				$r = clientInitialized;
				return $r;
			}(this))).error(deferred.reject);
			return deferred;
		}
		
		public function get(id : String) : fovea.ganomede.GanomedeTurnGame {
			if(this.idMap.exists(id)) {
				var client : fovea.ganomede.GanomedeClient = this.pool.getClient(this.idMap.get(id));
				return client.turngames.get(id);
			}
			else return null;
			return null;
		}
		
		public function refresh(turngame : fovea.ganomede.GanomedeTurnGame) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeTurnGamesComposite = this;
			if(this.idMap.exists(turngame.id)) {
				var client : fovea.ganomede.GanomedeClient = this.pool.getClient(this.idMap.get(turngame.id));
				return client.turngames.refresh(turngame);
			};
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(turngame.url != null) this.prepareClient(turngame).then((function($this:GanomedeTurnGamesComposite) : Function {
				var $r : Function;
				var clientPrepared : Function = function(result : *) : void {
					var client1 : fovea.ganomede.GanomedeClient = fovea.ganomede.GanomedeClient(result.client);
					client1.turngames.refresh(turngame).then(function() : Function {
						var $r2 : Function;
						var turngamesRefreshed : Function = function(outcome : *) : void {
							_g.idMap.set(turngame.id,result.id);
							deferred.resolve(result);
						}
						$r2 = turngamesRefreshed;
						return $r2;
					}()).error(deferred.reject);
				}
				$r = clientPrepared;
				return $r;
			}(this))).error(deferred.reject);
			else deferred.reject(new fovea.ganomede.ApiError("HTTP",400));
			return deferred;
		}
		
		public function addMove(turngame : fovea.ganomede.GanomedeTurnGame,turnmove : fovea.ganomede.GanomedeTurnMove) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.prepareClient(turngame).then((function($this:GanomedeTurnGamesComposite) : Function {
				var $r : Function;
				var clientPrepared : Function = function(result : *) : void {
					var client : fovea.ganomede.GanomedeClient = fovea.ganomede.GanomedeClient(result.client);
					client.turngames.addMove(turngame,turnmove).then(deferred.resolve).error(deferred.reject);
				}
				$r = clientPrepared;
				return $r;
			}(this))).error(deferred.reject);
			return deferred;
		}
		
		public function refreshArray(array : Array,on404 : Function = null) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeTurnGamesComposite = this;
			return fovea.async.Parallel.runWithArgs(array,function(turngame : fovea.ganomede.GanomedeTurnGame) : fovea.async.Promise {
				var deferred : fovea.async.Deferred = new fovea.async.Deferred();
				_g.refresh(turngame).always(function() : void {
					deferred.resolve(null);
				}).error(function(error : Error) : void {
					if(on404 != null) on404(turngame,error);
				});
				return deferred;
			});
		}
		
	}
}
