package fovea.ganomede {
	import flash.events.Event;
	import fovea.ganomede.GanomedeUser;
	import fovea.async.Deferred;
	import fovea.ganomede.ApiError;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeClient;
	import fovea.ganomede.ApiClient;
	import flash.Boot;
	public class GanomedeUsers extends fovea.ganomede.ApiClient {
		public function GanomedeUsers(client : fovea.ganomede.GanomedeClient = null) : void { if( !flash.Boot.skip_constructor ) {
			super(client.url + "/" + "users/v1");
			this.client = client;
		}}
		
		public var initialized : Boolean = false;
		public var client : fovea.ganomede.GanomedeClient = null;
		public var me : fovea.ganomede.GanomedeUser = new fovea.ganomede.GanomedeUser();
		public function initialize() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeUsers = this;
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			deferred.resolve();
			return deferred.then((function($this:GanomedeUsers) : Function {
				var $r : Function;
				var initializedFn : Function = function(obj : *) : void {
					_g.initialized = true;
					if(_g.me.isAuthenticated()) _g.dispatchLoginEvent(null);
				}
				$r = initializedFn;
				return $r;
			}(this)));
		}
		
		protected function dispatchLoginEvent(result : *) : void {
			this.dispatchEvent(new flash.events.Event("ganomede.login"));
		}
		
		public function signUp(user : fovea.ganomede.GanomedeUser) : fovea.async.Promise {
			this.me = user;
			return this.ajax("POST","/accounts",{ data : user.toJSON(), parse : this.parseMe}).then(this.dispatchLoginEvent);
		}
		
		public function passwordResetEmail() : fovea.async.Promise {
			return this.ajax("POST","/auth/" + this.me.token + "/passwordResetEmail");
		}
		
		public function forgotPassword(email : String) : fovea.async.Promise {
			return this.ajax("POST","/passwordResetEmail",{ data : { email : email}});
		}
		
		public function login(user : fovea.ganomede.GanomedeUser) : fovea.async.Promise {
			this.me = user;
			return this.ajax("POST","/login",{ data : { username : user.username, password : user.password, facebookId : user.facebookId, facebookToken : user.facebookToken}, parse : this.parseMe}).then(this.dispatchLoginEvent);
		}
		
		public function logout() : void {
			this.me = new fovea.ganomede.GanomedeUser();
			this.dispatchEvent(new flash.events.Event("ganomede.logout"));
		}
		
		public function fetch(user : fovea.ganomede.GanomedeUser) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(user.username == this.me.username || user.email == this.me.username || user.username == this.me.email) this.ajax("GET","/auth/" + this.me.token + "/me",{ parse : this.parseMe}).then((function($this:GanomedeUsers) : Function {
				var $r : Function;
				var fetched : Function = function(outcome : *) : void {
					deferred.resolve(user);
				}
				$r = fetched;
				return $r;
			}(this))).error(deferred.reject);
			else deferred.reject(new fovea.ganomede.ApiError("IO"));
			return deferred;
		}
		
		public function loadUserMetadata(username : String,key : String) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			var endpoint : String = "/" + username + "/metadata/" + key;
			var obj : * = this.cached("GET",endpoint);
			if(obj) deferred.resolve(obj.data);
			else this.cachedAjax("GET",endpoint).then((function($this:GanomedeUsers) : Function {
				var $r : Function;
				var metadataLoaded : Function = function(obj1 : *) : void {
					deferred.resolve(obj1.data);
				}
				$r = metadataLoaded;
				return $r;
			}(this))).error(deferred.reject);
			return deferred;
		}
		
		public function loadMetadata(key : String) : fovea.async.Promise {
			return this.loadUserMetadata(this.me.username,key);
		}
		
		public function saveMetadata(key : String,value : String) : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeUsers = this;
			var endpoint : String = "/auth/" + this.me.token + "/metadata/" + key;
			var data : * = { value : value};
			return this.ajax("POST",endpoint,{ data : data}).then((function($this:GanomedeUsers) : Function {
				var $r : Function;
				var metadataSaved : Function = function(outcome : *) : void {
					var endpoint1 : String = "/" + _g.me.username + "/metadata/" + key;
					_g.setCache("GET",endpoint1,{ status : 200, data : data});
				}
				$r = metadataSaved;
				return $r;
			}(this)));
		}
		
		public var friends : Array = new Array();
		public function refreshFriends() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeUsers = this;
			var endpoint : String = "/auth/" + this.me.token + "/friends";
			return this.ajax("GET",endpoint).then((function($this:GanomedeUsers) : Function {
				var $r : Function;
				var friendsRefreshed : Function = function(outcome : *) : void {
					_g.friends = outcome.data;
				}
				$r = friendsRefreshed;
				return $r;
			}(this)));
		}
		
		protected function parseMe(obj : *) : * {
			var oldToken : String = this.me.token;
			var oldUsername : String = this.me.username;
			this.me.fromJSON(obj);
			if(this.me.token != oldToken || this.me.username != oldUsername) this.dispatchEvent(new flash.events.Event("ganomede.auth"));
			return this.me;
		}
		
		static public var TYPE : String = "users/v1";
	}
}
