package fovea.ganomede {
	import flash.events.Event;
	import fovea.ganomede.AuthenticatedClient;
	import fovea.async.Deferred;
	import fovea.ganomede.ApiError;
	import fovea.net.Ajax;
	import fovea.async.Promise;
	import haxe.Log;
	import fovea.ganomede.GanomedeClient;
	import fovea.ganomede.ApiClient;
	import fovea.utils.Collection;
	import flash.Boot;
	public class UserClient extends fovea.ganomede.ApiClient {
		public function UserClient(client : fovea.ganomede.GanomedeClient = null,clientFactory : Function = null,type : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(client.url + (((type != null)?"/" + type:"")));
			this.client = client;
			this.clientFactory = clientFactory;
			this.authClient = clientFactory(client.url,null);
		}}
		
		public var initialized : Boolean = false;
		public var client : fovea.ganomede.GanomedeClient;
		public var authClient : fovea.ganomede.AuthenticatedClient = null;
		public var clientFactory : Function;
		public function initialize() : fovea.async.Promise {
			var _g : fovea.ganomede.UserClient = this;
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.client.users.addEventListener("ganomede.login",this.onLoginLogout);
			this.client.users.addEventListener("ganomede.logout",this.onLoginLogout);
			this.client.users.addEventListener("ganomede.auth",this.onLoginLogout);
			deferred.resolve();
			return deferred.then(function(outcome : *) : void {
				_g.initialized = true;
				_g.dispatchEvent(new flash.events.Event("change:initialize"));
			});
		}
		
		public function executeAuth(f : Function) : fovea.async.Promise {
			var _g : fovea.ganomede.UserClient = this;
			var cid0 : String = this.getClientID();
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(!this.isAuthOK()) return deferred;
			f().then(function(outcome : *) : void {
				if(cid0 == _g.getClientID() && _g.isAuthOK()) deferred.resolve(outcome);
			}).error(function(err : Error) : void {
				if(cid0 == _g.getClientID() && _g.isAuthOK()) deferred.reject(err);
			});
			return deferred;
		}
		
		public function getToken() : String {
			if(this.authClient != null) return this.authClient.token;
			else return null;
			return null;
		}
		
		public function getClientID() : String {
			if(this.authClient != null) return this.authClient.clientId;
			else return null;
			return null;
		}
		
		public function isAuthOK() : Boolean {
			return this.getToken() != null && this.client.users.me.token == this.getToken();
		}
		
		protected function onLoginLogout(event : flash.events.Event) : void {
			var oldAuthToken : String = null;
			if(this.authClient != null) oldAuthToken = this.authClient.token;
			var newAuthToken : String = null;
			if(this.client.users.me != null) newAuthToken = this.client.users.me.token;
			if(newAuthToken != oldAuthToken) {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("[UserClient] reset",{ fileName : "UserClient.hx", lineNumber : 88, className : "fovea.ganomede.UserClient", methodName : "onLoginLogout"});
				this.authClient = (this.clientFactory)(this.client.url,newAuthToken);
				this.dispatchEvent(new flash.events.Event("reset"));
			}
		}
		
		public function refreshCollection(collection : fovea.utils.Collection,ajaxCall : Function) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(this.authClient.token != null) this.executeAuth(ajaxCall).then(function(result : *) : void {
				if(collection.canMerge(result)) {
					collection.merge(result);
					deferred.resolve();
				}
				else deferred.reject(new fovea.ganomede.ApiError("IO"));
			}).error(deferred.reject);
			else {
				if(fovea.net.Ajax.verbose) haxe.Log._trace("Can't load if not authenticated",{ fileName : "UserClient.hx", lineNumber : 110, className : "fovea.ganomede.UserClient", methodName : "refreshCollection"});
				deferred.reject(new fovea.ganomede.ApiError("CLIENT"));
			};
			return deferred;
		}
		
	}
}
