package fovea.ganomede.helpers {
	import fovea.ganomede.GanomedeTurnGame;
	import fovea.async.Deferred;
	import fovea.ganomede.ApiError;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeGame;
	import fovea.async.Waterfall;
	import fovea.ganomede.GanomedeInvitation;
	import flash.Boot;
	import fovea.ganomede.Ganomede;
	public class GanomedeTurnGameInvitation extends fovea.ganomede.GanomedeInvitation {
		public function GanomedeTurnGameInvitation(client : fovea.ganomede.Ganomede = null,obj : * = null) : void { if( !flash.Boot.skip_constructor ) {
			this.client = client;
			super(obj);
		}}
		
		public var client : fovea.ganomede.Ganomede;
		protected function alreadyHasGameWith(friend : String) : Boolean {
			var array : Array = this.client.games.collection.asArray();
			{
				var _g1 : int = 0;
				var _g : int = array.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					var g : fovea.ganomede.GanomedeGame = fovea.ganomede.GanomedeGame(array[i]);
					if(g.status != "gameover") {
						var _g3 : int = 0;
						var _g2 : int = g.players.length;
						while(_g3 < _g2) {
							var j : int = _g3++;
							if(g.players[j] == friend) return true;
						}
					}
				}
			};
			return false;
		}
		
		protected function alreadyHasInvitationTo(friend : String) : Boolean {
			var array : Array = this.client.invitations.collection.asArray();
			{
				var _g1 : int = 0;
				var _g : int = array.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					var g : fovea.ganomede.GanomedeInvitation = fovea.ganomede.GanomedeInvitation(array[i]);
					if(g.to == friend) return true;
				}
			};
			return false;
		}
		
		public function canInvite(friend : String) : Boolean {
			return !this.alreadyHasGameWith(friend) && !this.alreadyHasInvitationTo(friend);
		}
		
		public function send(game : fovea.ganomede.GanomedeGame,force : Boolean = false) : fovea.async.Promise {
			var _g : fovea.ganomede.helpers.GanomedeTurnGameInvitation = this;
			var friend : String = game.players[game.players.length - 1];
			return fovea.async.Waterfall.run([function() : fovea.async.Promise {
				var deferred : fovea.async.Deferred = new fovea.async.Deferred();
				if(!force && _g.alreadyHasGameWith(friend)) deferred.reject(new fovea.ganomede.ApiError("HTTP",400,{ code : "DuplicateGame", message : "A game with this player already exists"}));
				else deferred.resolve(null);
				return deferred;
			},function() : fovea.async.Promise {
				var deferred1 : fovea.async.Deferred = new fovea.async.Deferred();
				if(!force && _g.alreadyHasInvitationTo(friend)) deferred1.reject(new fovea.ganomede.ApiError("HTTP",400,{ code : "DuplicateInvitation", message : "An invitation with this player already exists"}));
				else deferred1.resolve(null);
				return deferred1;
			},function() : fovea.async.Promise {
				return _g.client.games.add(game);
			},function() : fovea.async.Promise {
				var turngame : fovea.ganomede.GanomedeTurnGame = new fovea.ganomede.GanomedeTurnGame(game.toJSON());
				return _g.client.turngames.add(turngame);
			},function() : fovea.async.Promise {
				_g.fromJSON({ type : game.type, to : friend, gameId : game.id});
				return _g.client.invitations.add(_g);
			}]);
		}
		
		public function accept() : fovea.async.Promise {
			var _g : fovea.ganomede.helpers.GanomedeTurnGameInvitation = this;
			return fovea.async.Waterfall.run([function() : fovea.async.Promise {
				return _g.client.invitations.accept(_g);
			},function() : fovea.async.Promise {
				return _g.client.games.join(new fovea.ganomede.GanomedeGame({ id : _g.gameId}));
			}]);
		}
		
	}
}
