package fovea.net {
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import fovea.async.Deferred;
	import flash.events.HTTPStatusEvent;
	import flash.events.IEventDispatcher;
	import fovea.net.IAjax;
	import fovea.net.Ajax;
	import flash.events.SecurityErrorEvent;
	import fovea.async.Promise;
	import flash.events.IOErrorEvent;
	import fovea.net.AjaxError;
	import flash.net.URLRequestHeader;
	import flash.Boot;
	public class AjaxOpenFL implements fovea.net.IAjax{
		public function AjaxOpenFL(parent : fovea.net.Ajax = null) : void { if( !flash.Boot.skip_constructor ) {
			this.parent = parent;
		}}
		
		public var parent : fovea.net.Ajax;
		protected function beforeAjax(options : *) : void {
			this.parent.beforeAjax(options);
		}
		
		protected function afterAjax(options : *,obj : *) : void {
			this.parent.afterAjax(options,obj);
		}
		
		protected function ajaxError(code : String,status : int = 0,data : * = null,url : String = null) : fovea.net.AjaxError {
			return this.parent.ajaxError(code,status,data,url);
		}
		
		public function url() : String {
			return this.parent.url;
		}
		
		public function ajax(method : String,path : String,options : * = null) : fovea.async.Promise {
			if(options == null) options = { };
			options.method = method;
			options.path = path;
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			var requestID : String = StringTools.hex(Math.floor(Math.random() * 65535));
			options.requestID = requestID;
			(fovea.net.Ajax.dtrace)("AJAX[" + requestID + "] " + method + " " + this.url() + path);
			this.beforeAjax(options);
			var urlRequest : flash.net.URLRequest = new flash.net.URLRequest(this.url() + path);
			urlRequest.method = method.toUpperCase();
			if(options.data) {
				urlRequest.data = JSON.stringify(options.data);
				(fovea.net.Ajax.dtrace)("AJAX[" + requestID + "] data=" + Std.string(urlRequest.data));
			};
			urlRequest.requestHeaders.push(new flash.net.URLRequestHeader("Content-type","application/json"));
			urlRequest.requestHeaders.push(new flash.net.URLRequestHeader("Accept","application/json"));
			var urlLoader : flash.net.URLLoader = new flash.net.URLLoader();
			this.configureListeners(urlLoader,deferred,options);
			urlLoader.load(urlRequest);
			return deferred;
		}
		
		protected function configureListeners(dispatcher : flash.events.IEventDispatcher,deferred : fovea.async.Deferred,options : *) : void {
			var _g : fovea.net.AjaxOpenFL = this;
			var status : int = 0;
			var data : * = null;
			var removeListeners : Function = null;
			var done : Function = function() : void {
				removeListeners(dispatcher);
				if(status >= 200 && status <= 299) {
					fovea.net.Ajax.connection.dispatchEvent(fovea.net.Ajax.onlineEvent);
					(fovea.net.Ajax.dtrace)("AJAX[" + Std.string(options.requestID) + "] success[" + status + "]: " + JSON.stringify(data));
					var obj : * = { status : status, data : data};
					_g.afterAjax(options,obj);
					deferred.resolve(obj);
				}
				else {
					(fovea.net.Ajax.dtrace)("AJAX[" + Std.string(options.requestID) + "] error[" + status + "]: " + JSON.stringify(data));
					deferred.reject(_g.ajaxError("HTTP",status,data));
				}
			};
			var complete : Function = function(event : flash.events.Event) : void {
				var loader : flash.net.URLLoader;
				loader = function() : flash.net.URLLoader {
					var $r : flash.net.URLLoader;
					var $t : * = event.target;
					if(Std._is($t,flash.net.URLLoader)) (($t) as flash.net.URLLoader);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}();
				data = _g.jsonData(loader);
				done();
			};
			var httpStatus : Function = function(event1 : flash.events.HTTPStatusEvent) : void {
				status = event1.status;
				(fovea.net.Ajax.dtrace)("AJAX[" + Std.string(options.requestID) + "] status[" + status + "]");
			};
			var securityError : Function = function(event2 : flash.events.SecurityErrorEvent) : void {
				removeListeners(dispatcher);
				deferred.reject(_g.ajaxError("SECURITY"));
				fovea.net.Ajax.connection.dispatchEvent(fovea.net.Ajax.offlineEvent);
			};
			var ioError : Function = function(event3 : flash.events.IOErrorEvent) : void {
				var loader1 : flash.net.URLLoader;
				loader1 = function() : flash.net.URLLoader {
					var $r2 : flash.net.URLLoader;
					var $t : * = event3.target;
					if(Std._is($t,flash.net.URLLoader)) (($t) as flash.net.URLLoader);
					else throw "Class cast error";
					$r2 = $t;
					return $r2;
				}();
				data = _g.jsonData(loader1);
				if(data) done();
				else {
					(fovea.net.Ajax.dtrace)("AJAX[" + Std.string(options.requestID) + "] ioErrorHandler: " + Std.string(event3));
					removeListeners(dispatcher);
					deferred.reject(_g.ajaxError("IO",status,data));
					if(!options.silentIOError) fovea.net.Ajax.connection.dispatchEvent(fovea.net.Ajax.offlineEvent);
				}
			};
			dispatcher.addEventListener(flash.events.Event.COMPLETE,complete);
			dispatcher.addEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR,securityError);
			dispatcher.addEventListener(flash.events.IOErrorEvent.IO_ERROR,ioError);
			dispatcher.addEventListener(flash.events.HTTPStatusEvent.HTTP_STATUS,httpStatus);
			removeListeners = function(dispatcher1 : flash.events.IEventDispatcher) : void {
				dispatcher1.removeEventListener(flash.events.Event.COMPLETE,complete);
				dispatcher1.removeEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR,securityError);
				dispatcher1.removeEventListener(flash.events.IOErrorEvent.IO_ERROR,ioError);
				dispatcher1.removeEventListener(flash.events.HTTPStatusEvent.HTTP_STATUS,httpStatus);
			}
		}
		
		protected function jsonData(urlLoader : flash.net.URLLoader) : * {
			var json : * = null;
			try {
				if(urlLoader.data) json = JSON.parse(urlLoader.data.toString());
			}
			catch( e : * ){
				(fovea.net.Ajax.dtrace)("[AJAX] JSON parsing Error (" + Std.string(e) + ")");
				(fovea.net.Ajax.dtrace)("[AJAX] data = \"" + Std.string(urlLoader.data.toString()) + "\"");
			};
			return json;
		}
		
		static public function factory(parent : fovea.net.Ajax) : fovea.net.IAjax {
			return new fovea.net.AjaxOpenFL(parent);
		}
		
	}
}
