package fovea.net {
	import flash.events.Event;
	import flash.net.URLRequest;
	import fovea.net.FilePart;
	import flash.net.URLLoader;
	import flash.utils.Endian;
	import flash.errors.IllegalOperationError;
	import flash.events.ProgressEvent;
	import flash.net.URLRequestMethod;
	import flash.events.HTTPStatusEvent;
	import flash.events.EventDispatcher;
	import flash.events.SecurityErrorEvent;
	import fovea.net.MultipartURLLoaderEvent;
	import flash.net.URLLoaderDataFormat;
	import flash.utils.ByteArray;
	import flash.events.IOErrorEvent;
	import haxe.Timer;
	import haxe.ds.StringMap;
	import flash.net.URLRequestHeader;
	import flash.Boot;
	public class MultipartURLLoader extends flash.events.EventDispatcher {
		public function MultipartURLLoader() : void { if( !flash.Boot.skip_constructor ) {
			super();
		}}
		
		protected var _loader : flash.net.URLLoader = new flash.net.URLLoader();
		protected var _boundary : String;
		protected var _variableNames : Array = new Array();
		protected var _fileNames : Array = new Array();
		protected var _variables : haxe.ds.StringMap = new haxe.ds.StringMap();
		protected var _files : haxe.ds.StringMap = new haxe.ds.StringMap();
		protected var _async : Boolean = false;
		protected var _path : String;
		protected var _data : flash.utils.ByteArray;
		protected var _prepared : Boolean = false;
		protected var asyncWriteTimeoutId : haxe.Timer;
		protected var asyncFilePointer : int = 0;
		protected var totalFilesSize : uint = uint(0);
		protected var writtenBytes : uint = uint(0);
		public var requestHeaders : Array = new Array();
		public function load(path : String,async : Boolean = false) : void {
			if(path == null || path == "") throw new flash.errors.IllegalOperationError("You cant load without specifing PATH");
			this._path = path;
			this._async = async;
			if(this._async) {
				if(!this._prepared) this.constructPostDataAsync();
				else this.doSend();
			}
			else {
				this._data = this.constructPostData();
				this.doSend();
			}
		}
		
		public function startLoad() : void {
			if(this._path == null || this._path == "" || this._async == false) throw new flash.errors.IllegalOperationError("You can use this method only if loading asynchronous.");
			if(!this._prepared && this._async) throw new flash.errors.IllegalOperationError("You should prepare data before sending when using asynchronous.");
			this.doSend();
		}
		
		public function prepareData() : void {
			this.constructPostDataAsync();
		}
		
		public function close() : void {
			try {
				this._loader.close();
			}
			catch( e : Error ){
			}
		}
		
		public function addVariable(name : String,value : * = "") : void {
			if(value==null) value="";
			if(this._variableNames.indexOf(name) == -1) this._variableNames.push(name);
			this._variables.set(name,value);
			this._prepared = false;
		}
		
		public function addFile(fileContent : flash.utils.ByteArray,fileName : String,dataField : String = "Filedata",contentType : String = "application/octet-stream") : void {
			if(dataField==null) dataField="Filedata";
			if(contentType==null) contentType="application/octet-stream";
			if(this._fileNames.indexOf(fileName) == -1) {
				this._fileNames.push(fileName);
				this._files.set(fileName,new fovea.net.FilePart(fileContent,fileName,dataField,contentType));
				this.totalFilesSize += fileContent.length;
			}
			else {
				var f : fovea.net.FilePart = this._files.get(fileName);
				this.totalFilesSize -= f.fileContent.length;
				f.fileContent = fileContent;
				f.fileName = fileName;
				f.dataField = dataField;
				f.contentType = contentType;
				this.totalFilesSize += fileContent.length;
			};
			this._prepared = false;
		}
		
		public function clearVariables() : void {
			this._variableNames = new Array();
			this._variables = new haxe.ds.StringMap();
			this._prepared = false;
		}
		
		public function clearFiles() : void {
			{
				var _g1 : int = 0;
				var _g : int = this._fileNames.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					var name : String = this._fileNames[i];
					this._files.get(name).dispose();
				}
			};
			this._fileNames = new Array();
			this._files = new haxe.ds.StringMap();
			this.totalFilesSize = 0;
			this._prepared = false;
		}
		
		public function dispose() : void {
			if(this.asyncWriteTimeoutId != null) {
				this.asyncWriteTimeoutId.stop();
				this.asyncWriteTimeoutId = null;
			};
			this.removeListener();
			this.close();
			this._loader = null;
			this._boundary = null;
			this._variableNames = null;
			this._variables = null;
			this._fileNames = null;
			this._files = null;
			this.requestHeaders = null;
			this._data = null;
		}
		
		public function getBoundary() : String {
			if(this._boundary == null) {
				this._boundary = "";
				{
					var _g : int = 0;
					while(_g < 32) {
						var i : int = _g++;
						this._boundary += String.fromCharCode((function($this:MultipartURLLoader) : int {
							var $r : int;
							var $t : Number = 97 + Math.random() * 25;
							if(Std._is($t,int)) (($t) as int);
							else throw "Class cast error";
							$r = $t;
							return $r;
						}(this)));
					}
				}
			};
			return this._boundary;
		}
		
		public function getAsync() : Boolean {
			return this._async;
		}
		
		public function getPrepared() : Boolean {
			return this._prepared;
		}
		
		public function getDataFormat() : String {
			return this._loader.dataFormat;
		}
		
		public function setDataFormat(format : String) : void {
			if(format != flash.net.URLLoaderDataFormat.BINARY && format != flash.net.URLLoaderDataFormat.TEXT && format != flash.net.URLLoaderDataFormat.VARIABLES) throw new flash.errors.IllegalOperationError("Illegal URLLoader Data Format");
			this._loader.dataFormat = format;
		}
		
		public function getLoader() : flash.net.URLLoader {
			return this._loader;
		}
		
		protected function doSend() : void {
			var urlRequest : flash.net.URLRequest = new flash.net.URLRequest();
			urlRequest.url = this._path;
			urlRequest.method = flash.net.URLRequestMethod.POST;
			urlRequest.data = this._data;
			urlRequest.requestHeaders.push(new flash.net.URLRequestHeader("Content-type","multipart/form-data; boundary=" + this.getBoundary()));
			if(this.requestHeaders.length > 0) urlRequest.requestHeaders = urlRequest.requestHeaders.concat(this.requestHeaders);
			this.addListener();
			this._loader.load(urlRequest);
		}
		
		protected function constructPostDataAsync() : void {
			if(this.asyncWriteTimeoutId != null) {
				this.asyncWriteTimeoutId.stop();
				this.asyncWriteTimeoutId = null;
			};
			this._data = new flash.utils.ByteArray();
			this._data.endian = flash.utils.Endian.BIG_ENDIAN;
			this._data = this.constructVariablesPart(this._data);
			this.asyncFilePointer = 0;
			this.writtenBytes = 0;
			this._prepared = false;
			if(this._fileNames.length > 0) this.nextAsyncLoop();
			else {
				this._data = this.closeDataObject(this._data);
				this._prepared = true;
				this.dispatchEvent(new fovea.net.MultipartURLLoaderEvent("dataPrepareComplete"));
			}
		}
		
		protected function constructPostData() : flash.utils.ByteArray {
			var postData : flash.utils.ByteArray = new flash.utils.ByteArray();
			postData.endian = flash.utils.Endian.BIG_ENDIAN;
			postData = this.constructVariablesPart(postData);
			postData = this.constructFilesPart(postData);
			postData = this.closeDataObject(postData);
			return postData;
		}
		
		protected function closeDataObject(postData : flash.utils.ByteArray) : flash.utils.ByteArray {
			postData = this.BOUNDARY(postData);
			postData = this.DOUBLEDASH(postData);
			return postData;
		}
		
		protected function constructVariablesPart(postData : flash.utils.ByteArray) : flash.utils.ByteArray {
			var i : uint;
			var bytes : String;
			{
				var _g1 : int = 0;
				var _g : int = this._variableNames.length;
				while(_g1 < _g) {
					var index : int = _g1++;
					var name : String = this._variableNames[index];
					postData = this.BOUNDARY(postData);
					postData = this.LINEBREAK(postData);
					bytes = "Content-Disposition: form-data; name=\"" + name + "\"";
					{
						var _g3 : int = 0;
						var _g2 : int = bytes.length;
						while(_g3 < _g2) {
							var i1 : int = _g3++;
							postData.writeByte(bytes["charCodeAtHX"](i1));
						}
					};
					postData = this.LINEBREAK(postData);
					postData = this.LINEBREAK(postData);
					postData.writeUTFBytes(this._variables.get(name));
					postData = this.LINEBREAK(postData);
				}
			};
			return postData;
		}
		
		protected function constructFilesPart(postData : flash.utils.ByteArray) : flash.utils.ByteArray {
			var i : int = 0;
			var bytes : String;
			if(this._fileNames.length > 0) {
				{
					var _g1 : int = 0;
					var _g : int = this._fileNames.length;
					while(_g1 < _g) {
						var index : int = _g1++;
						var name : String = this._fileNames[index];
						postData = this.getFilePartHeader(postData,this._files.get(name));
						postData = this.getFilePartData(postData,this._files.get(name));
						if(i != this._fileNames.length - 1) postData = this.LINEBREAK(postData);
						i++;
					}
				};
				postData = this.closeFilePartsData(postData);
			};
			return postData;
		}
		
		protected function closeFilePartsData(postData : flash.utils.ByteArray) : flash.utils.ByteArray {
			var bytes : String;
			postData = this.LINEBREAK(postData);
			postData = this.BOUNDARY(postData);
			postData = this.LINEBREAK(postData);
			bytes = "Content-Disposition: form-data; name=\"Upload\"";
			{
				var _g1 : int = 0;
				var _g : int = bytes.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					postData.writeByte(bytes["charCodeAtHX"](i));
				}
			};
			postData = this.LINEBREAK(postData);
			postData = this.LINEBREAK(postData);
			bytes = "Submit Query";
			{
				var _g11 : int = 0;
				var _g2 : int = bytes.length;
				while(_g11 < _g2) {
					var i1 : int = _g11++;
					postData.writeByte(bytes["charCodeAtHX"](i1));
				}
			};
			postData = this.LINEBREAK(postData);
			return postData;
		}
		
		protected function getFilePartHeader(postData : flash.utils.ByteArray,part : fovea.net.FilePart) : flash.utils.ByteArray {
			var bytes : String;
			postData = this.BOUNDARY(postData);
			postData = this.LINEBREAK(postData);
			bytes = "Content-Disposition: form-data; name=\"Filename\"";
			{
				var _g1 : int = 0;
				var _g : int = bytes.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					postData.writeByte(bytes["charCodeAtHX"](i));
				}
			};
			postData = this.LINEBREAK(postData);
			postData = this.LINEBREAK(postData);
			postData.writeUTFBytes(part.fileName);
			postData = this.LINEBREAK(postData);
			postData = this.BOUNDARY(postData);
			postData = this.LINEBREAK(postData);
			bytes = "Content-Disposition: form-data; name=\"" + part.dataField + "\"; filename=\"";
			{
				var _g11 : int = 0;
				var _g2 : int = bytes.length;
				while(_g11 < _g2) {
					var i1 : int = _g11++;
					postData.writeByte(bytes["charCodeAtHX"](i1));
				}
			};
			postData.writeUTFBytes(part.fileName);
			postData = this.QUOTATIONMARK(postData);
			postData = this.LINEBREAK(postData);
			bytes = "Content-Type: " + part.contentType;
			{
				var _g12 : int = 0;
				var _g3 : int = bytes.length;
				while(_g12 < _g3) {
					var i2 : int = _g12++;
					postData.writeByte(bytes["charCodeAtHX"](i2));
				}
			};
			postData = this.LINEBREAK(postData);
			postData = this.LINEBREAK(postData);
			return postData;
		}
		
		protected function getFilePartData(postData : flash.utils.ByteArray,part : fovea.net.FilePart) : flash.utils.ByteArray {
			postData.writeBytes(part.fileContent,0,part.fileContent.length);
			return postData;
		}
		
		protected function onProgress(event : flash.events.ProgressEvent) : void {
			this.dispatchEvent(event);
		}
		
		protected function onComplete(event : flash.events.Event) : void {
			this.removeListener();
			this.dispatchEvent(event);
		}
		
		protected function onIOError(event : flash.events.IOErrorEvent) : void {
			this.removeListener();
			this.dispatchEvent(event);
		}
		
		protected function onSecurityError(event : flash.events.SecurityErrorEvent) : void {
			this.removeListener();
			this.dispatchEvent(event);
		}
		
		protected function onHTTPStatus(event : flash.events.HTTPStatusEvent) : void {
			this.dispatchEvent(event);
		}
		
		protected function addListener() : void {
			this._loader.addEventListener(flash.events.Event.COMPLETE,this.onComplete,false,0,false);
			this._loader.addEventListener(flash.events.ProgressEvent.PROGRESS,this.onProgress,false,0,false);
			this._loader.addEventListener(flash.events.IOErrorEvent.IO_ERROR,this.onIOError,false,0,false);
			this._loader.addEventListener(flash.events.HTTPStatusEvent.HTTP_STATUS,this.onHTTPStatus,false,0,false);
			this._loader.addEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR,this.onSecurityError,false,0,false);
		}
		
		protected function removeListener() : void {
			this._loader.removeEventListener(flash.events.Event.COMPLETE,this.onComplete);
			this._loader.removeEventListener(flash.events.ProgressEvent.PROGRESS,this.onProgress);
			this._loader.removeEventListener(flash.events.IOErrorEvent.IO_ERROR,this.onIOError);
			this._loader.removeEventListener(flash.events.HTTPStatusEvent.HTTP_STATUS,this.onHTTPStatus);
			this._loader.removeEventListener(flash.events.SecurityErrorEvent.SECURITY_ERROR,this.onSecurityError);
		}
		
		protected function BOUNDARY(p : flash.utils.ByteArray) : flash.utils.ByteArray {
			var l : int = this.getBoundary().length;
			p = this.DOUBLEDASH(p);
			{
				var _g : int = 0;
				while(_g < l) {
					var i : int = _g++;
					p.writeByte(this._boundary["charCodeAtHX"](i));
				}
			};
			return p;
		}
		
		protected function LINEBREAK(p : flash.utils.ByteArray) : flash.utils.ByteArray {
			p.writeShort(3338);
			return p;
		}
		
		protected function QUOTATIONMARK(p : flash.utils.ByteArray) : flash.utils.ByteArray {
			p.writeByte(34);
			return p;
		}
		
		protected function DOUBLEDASH(p : flash.utils.ByteArray) : flash.utils.ByteArray {
			p.writeShort(11565);
			return p;
		}
		
		protected function nextAsyncLoop() : void {
			var _g : fovea.net.MultipartURLLoader = this;
			var fp : fovea.net.FilePart;
			if(this.asyncFilePointer < this._fileNames.length) {
				fp = this._files.get(this._fileNames[this.asyncFilePointer]);
				this._data = this.getFilePartHeader(this._data,fp);
				this.asyncWriteTimeoutId = haxe.Timer.delay(function() : void {
					_g.writeChunkLoop(_g._data,fp.fileContent,0);
				},10);
				this.asyncFilePointer++;
			}
			else {
				this._data = this.closeFilePartsData(this._data);
				this._data = this.closeDataObject(this._data);
				this._prepared = true;
				this.dispatchEvent(new fovea.net.MultipartURLLoaderEvent("dataPrepareProgress",this.totalFilesSize,this.totalFilesSize));
				this.dispatchEvent(new fovea.net.MultipartURLLoaderEvent("dataPrepareComplete"));
			}
		}
		
		protected function writeChunkLoop(dest : flash.utils.ByteArray,data : flash.utils.ByteArray,p : uint = 0) : void {
			var _g : fovea.net.MultipartURLLoader = this;
			var len : uint = uint(Math.min(65536,data.length - p));
			dest.writeBytes(data,p,len);
			if(len < 65536 || p + len >= data.length) {
				dest = this.LINEBREAK(dest);
				this.nextAsyncLoop();
				return;
			};
			p += len;
			this.writtenBytes += len;
			if(this.writtenBytes % 65536 * 2 == 0) this.dispatchEvent(new fovea.net.MultipartURLLoaderEvent("dataPrepareProgress",this.writtenBytes,this.totalFilesSize));
			this.asyncWriteTimeoutId = haxe.Timer.delay(function() : void {
				_g.writeChunkLoop(dest,data,p);
			},10);
		}
		
		static public var BLOCK_SIZE : uint = 65536;
	}
}
