package fovea.utils {
	import flash.events.Event;
	import fovea.events.Events;
	import fovea.utils._Collection.MergeNonExisting;
	import fovea.utils.Model;
	import fovea.utils._Collection.MergeExisting;
	import fovea.utils.StrategyChain;
	import fovea.utils._Collection.MergeArray;
	import fovea.utils.Strategy;
	import haxe.ds.StringMap;
	import flash.Boot;
	public class Collection extends fovea.events.Events {
		public function Collection() : void { if( !flash.Boot.skip_constructor ) {
			super();
			this.merger = new fovea.utils.StrategyChain([new fovea.utils._Collection.MergeArray(this),new fovea.utils._Collection.MergeExisting(this),new fovea.utils._Collection.MergeNonExisting(this)]);
		}}
		
		protected var map : haxe.ds.StringMap = new haxe.ds.StringMap();
		public var keepStrategy : Function = null;
		public var modelFactory : Function = null;
		protected var merger : fovea.utils.Strategy;
		public function asArray() : Array {
			var ret : Array = new Array();
			var keys : * = this.map.keys();
			{ var $it : * = keys;
			while( $it.hasNext() ) { var key : String = $it.next();
			ret.push(this.map.get(key));
			}};
			return ret;
		}
		
		public function toJSON() : * {
			var ret : Array = [];
			var keys : * = this.map.keys();
			{ var $it : * = keys;
			while( $it.hasNext() ) { var key : String = $it.next();
			ret.push(this.map.get(key).toJSON());
			}};
			return ret;
		}
		
		public function get(key : String) : fovea.utils.Model {
			return this.map.get(key);
		}
		
		public function del(key : String) : void {
			this.map.remove(key);
			this.dispatchEvent(new flash.events.Event("del:" + key));
			this.dispatchEvent(new flash.events.Event("del"));
		}
		
		public function set(key : String,value : fovea.utils.Model) : void {
			this.map.set(key,value);
			this.dispatchEvent(new flash.events.Event("set:" + key));
			this.dispatchEvent(new flash.events.Event("set"));
		}
		
		public function exists(key : String) : Boolean {
			return this.map.exists(key);
		}
		
		public function keep(keys : Array) : Boolean {
			var changed : Boolean = false;
			var keepKeys : haxe.ds.StringMap = new haxe.ds.StringMap();
			{
				var _g : int = 0;
				while(_g < keys.length) {
					var i : String = keys[_g];
					++_g;
					keepKeys.set(i,true);
				}
			};
			{ var $it : * = this.map.keys();
			while( $it.hasNext() ) { var key : String = $it.next();
			if(!keepKeys.get(key)) {
				this.del(key);
				changed = true;
			}
			}};
			return changed;
		}
		
		public function flushall() : void {
			var oldMap : haxe.ds.StringMap = this.map;
			this.map = new haxe.ds.StringMap();
			{ var $it : * = oldMap.keys();
			while( $it.hasNext() ) { var key : String = $it.next();
			this.dispatchEvent(new flash.events.Event("del:" + key));
			}};
			this.dispatchEvent(new flash.events.Event("del"));
		}
		
		public function shouldKeep(item : fovea.utils.Model) : Boolean {
			if(this.keepStrategy != null) return (this.keepStrategy)(item);
			else return true;
			return false;
		}
		
		public function newModel(json : *) : fovea.utils.Model {
			if(this.modelFactory != null) return (this.modelFactory)(json);
			else return null;
			return null;
		}
		
		public function merge(json : *) : Boolean {
			if((this.merger.canExecute)(json)) {
				var result : * = (this.merger.execute)(json);
				if(result != null && result.changed) {
					this.dispatchEvent(new flash.events.Event("change"));
					return true;
				}
				else return false;
			}
			else return false;
			return false;
		}
		
		public function canMerge(json : *) : Boolean {
			return (this.merger.canExecute)(json);
		}
		
	}
}
